#region Using Statements
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
#endregion

namespace SlidingBlockPuzzle {

	/// <summary>ubNzu</summary>
	public class Blocks {
		public const int Width = 4;
		public const int Height = 4;
		public const int NumberBlocks = Width * Height;
		public const byte EmptyBlock = 0;
		static readonly byte[] initialBlocks = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, EmptyBlock, };

		readonly byte[] blocks = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, EmptyBlock, };
		bool completed;

		public event EventHandler Completed;

		public bool IsCompleted { get { return completed; } }
		/// <summary>肪ǂ肷B</summary>
		public void Evaluate() {
			try {
				for (int i = 0; i < blocks.Length; i++) {
					if (blocks[i] != initialBlocks[i]) {
						completed = false;
						return;
					}
				}
				completed = true;
				if (Completed != null)
					Completed(this, EventArgs.Empty);
			} finally {
#if DEBUG
				Console.WriteLine(this);
#endif
			}
		}
		public void Clear() {
			initialBlocks.CopyTo(blocks, 0);
			completed = true;
		}
		public byte this[int index] {
			get { return blocks[index]; }
			set { blocks[index] = value; }
		}
		public int EmptyIndex {
			get {
				for (int i = 0; i < blocks.Length; i++) {
					if (blocks[i] == EmptyBlock)
						return i;
				}
				return -1; // ُȔՖ
			}
		}
		public override string ToString() {
			StringBuilder sb = new StringBuilder();
			for (int y = 0; y < Blocks.Height; y++) {
				for (int x = 0; x < Blocks.Width; x++) {
					sb.AppendFormat("{0:00} ", this[x + y * Blocks.Width]);
				}
				sb.AppendLine();
			}
			return sb.ToString();
		}
	}

}
