#region Using Statements
using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;
#endregion

namespace SlidingBlockPuzzle {

	[Flags]
	public enum Buttons {
		Up = 1 << 0,
		Down = 1 << 1,
		Left = 1 << 2,
		Right = 1 << 3,
		Okay = 1 << 4,
		Randomize = 1 << 5,
		Clear = 1 << 6,
	}

	public class Input {
		Buttons current;
		Buttons previous;
		Buttons down;
		Buttons up;

		public void Update(KeyboardState state) {
			previous = current;
			current = 0;

			if (state.IsKeyDown(Keys.Up))
				current |= Buttons.Up;
			if (state.IsKeyDown(Keys.Down))
				current |= Buttons.Down;
			if (state.IsKeyDown(Keys.Left))
				current |= Buttons.Left;
			if (state.IsKeyDown(Keys.Right))
				current |= Buttons.Right;
			if (state.IsKeyDown(Keys.Space))
				current |= Buttons.Okay;
			if (state.IsKeyDown(Keys.R))
				current |= Buttons.Randomize;
			if (state.IsKeyDown(Keys.C))
				current |= Buttons.Clear;

			down = current & ~previous;
			up = ~current & previous;
		}

		public Buttons Current { get { return current; } }
		public Buttons Previous { get { return previous; } }
		public Buttons Down { get { return down; } }
		public Buttons Up { get { return up; } }
	}

}
