#region Using Statements
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
#endregion

namespace SlidingBlockPuzzle {

	public class Randomizer {
		readonly Blocks blocks;
		readonly Random random = new Random();

		public Randomizer(Blocks blocks) {
			this.blocks = blocks;
		}
		/// <summary>_ȔՖʂB</summary>
		/// <param name="count">ubNւ</param>
		public void Randomize(int count) {
			blocks.Clear();

			for (int i = 0; i < count; i++) {
				Swap(random.Next(Blocks.NumberBlocks), random.Next(Blocks.NumberBlocks));
			}
			if (Parity)
				Mirror();

			blocks.Evaluate();
		}
		/// <summary>E𔽓]B</summary>
		public void Mirror() {
			for (int y = 0; y < Blocks.Height; y++) {
				int bias0 = y * Blocks.Width;
				int bias1 = bias0 + Blocks.Width - 1;
				for (int x = 0; x < Blocks.Width / 2; x++) {
					Swap(bias0 + x, bias1 - x);
				}
			}
		}
		/// <summary>ubNւB</summary>
		public void Swap(int index0, int index1) {
			byte x = blocks[index0];
			byte y = blocks[index1];
			blocks[index0] = y;
			blocks[index1] = x;
		}
		/// <summary>]|</summary>
		public int InversionNumber {
			get {
				int number = 0;
				for (int i = 1; i < Blocks.NumberBlocks; i++) {
					byte border = blocks[i - 1];
					if (border == Blocks.EmptyBlock)
						continue;
					for (int j = i; j < Blocks.NumberBlocks; j++) {
						byte block = blocks[j];
						if (block != Blocks.EmptyBlock && block < border)
							number++;
					}
				}
				return number;
			}
		}
		public bool Parity { get { return (InversionNumber & 1) != 0; } }
		public override string ToString() {
			return string.Format("IversionNumber={0} Parity={1}",
				InversionNumber, Parity ? "Odd" : "Even");
		}
	}

}
