#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
#endregion

namespace SlidingBlockPuzzle {

	public class Slider {
		readonly Blocks blocks;

		public delegate void MoveEventHandler(int index, int x, int y);
		public event MoveEventHandler Moved;

		public Slider(Blocks blocks) {
			this.blocks = blocks;
		}
		public bool Slide(int index) {
			int emptyIndex = blocks.EmptyIndex;
			int target = emptyIndex;
			Point a, b;
			a.X = index % Blocks.Width;
			a.Y = index / Blocks.Width;
			b.X = target % Blocks.Width;
			b.Y = target / Blocks.Width;

			Point difference;
			difference.X = b.X - a.X;
			difference.Y = b.Y - a.Y;

			int type = difference.X != 0 ? 1 : 0;
			type += difference.Y != 0 ? 2 : 0;

			switch (type) {
			default: // 0:ʒu 3:΂
				return false;
			case 1: { // 
					int step = Math.Sign(difference.X);
					for (int next; target != index; target = next) {
						next = target - step;
						blocks[target] = blocks[next];
						if (Moved != null)
							Moved(next, step, 0);
					}
				}
				break;
			case 2: { // c
					int d = Math.Sign(difference.Y);
					int step = d * Blocks.Width;
					for (int next; target != index; target = next) {
						next = target - step;
						blocks[target] = blocks[next];
						if (Moved != null)
							Moved(next, 0, d);
					}
				}
				break;
			}
			blocks[index] = 0; // 
			if (Moved != null)
				Moved(index, -difference.X, -difference.Y);
			blocks.Evaluate();

			return true;
		}
	}

}
