#region Using Statements
using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
#endregion

namespace SlidingBlockPuzzle {

	public class SlidingBlockPuzzleGame : Microsoft.Xna.Framework.Game {
		readonly GraphicsDeviceManager graphics;
		readonly ContentManager content;
		readonly BlocksControl control = new BlocksControl();
		readonly Visual visual;
		readonly Input input = new Input();

		public SlidingBlockPuzzleGame() {
			graphics = new GraphicsDeviceManager(this);
			content = new ContentManager(Services);
			control.Randomize();
			visual = new Visual(this, content, control);
			Components.Add(visual);
		}

		protected override void Initialize() {
			base.Initialize();
		}

		protected override void LoadGraphicsContent(bool loadAllContent) {
			if (loadAllContent) {
			}
		}

		protected override void UnloadGraphicsContent(bool unloadAllContent) {
			if (unloadAllContent) {
				content.Unload();
			}
		}

		protected override void Update(GameTime gameTime) {
			KeyboardState state = Keyboard.GetState();
			if (state.IsKeyDown(Keys.Escape) ||
				GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
				this.Exit();

			input.Update(state);
			if ((input.Down & Buttons.Up) != 0)
				control.Up();
			if ((input.Down & Buttons.Down) != 0)
				control.Down();
			if ((input.Down & Buttons.Left) != 0)
				control.Left();
			if ((input.Down & Buttons.Right) != 0)
				control.Right();
			if ((input.Down & Buttons.Okay) != 0)
				control.Do();
			if ((input.Down & Buttons.Randomize) != 0) {
				control.Randomize();
				visual.Clear();
			}
			if ((input.Down & Buttons.Clear) != 0) {
				control.Blocks.Clear();
				control.Clear();
				visual.Clear();
			}

			base.Update(gameTime);
		}

		protected override void Draw(GameTime gameTime) {
			if (control.Blocks.IsCompleted) {
				graphics.GraphicsDevice.Clear(Color.YellowGreen);
			} else {
				graphics.GraphicsDevice.Clear(Color.CornflowerBlue);
			}
			base.Draw(gameTime);
		}
	}

}
